#!/usr/bin/perl

use strict;
use lib qw(.);
use printcal;
use holiday;

my $diridx=holiday::diridx;
my $script=printcal::paramscr;

print "Content-type: text/html; charset=UTF-8\n\n";
$ENV{'TZ'}="JST-9";
my ($name, $value, %param);
my @qstr=split('&', $ENV{'QUERY_STRING'});
foreach my $ix (@qstr){
	($name, $value)=split('=', $ix);
	$value=~s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c', hex($1))/ge;
	$param{$name}=$value;
}
my ($toyear, $tomonth, $today);
if(defined $param{'year'}){ $toyear=$param{'year'}; }
else{ $toyear=Date::Simple->new()->format('%Y'); }
if(defined $param{'month'}){ $tomonth=$param{'month'}; }
else{ $tomonth=Date::Simple->new()->format('%m'); }
if(defined $param{'day'}){ $today=$param{'day'}; }
else{ $today=Date::Simple->new()->format('%d'); }
undef $param{'script'} if($param{'script'} eq "no");
$param{'col'}=3 if($param{'col'} eq "");
$param{'col'}=abs($param{'col'}) if($param{'col'}<0);
$param{'apr'}=1 if($param{'apr'} eq "");
undef $param{'header'} if($param{'header'} eq "no");
undef $param{'footer'} if($param{'footer'} eq "no");
$param{'dir'}=$ENV{'PATH_TRANSLATED'} if(defined $ENV{'PATH_TRANSLATED'});
$param{'dir'}=~s/$diridx.*//i;
$param{'dir'}=~s/\/$//;
my ($hpath, $fpath);
if(defined $param{'header'}){
	$param{'header'}=~s/^\///;
	$hpath=$param{'dir'}."/".$param{'header'};
	if( -f "$hpath"){
		open HEAD, "$hpath" or die;
		while(<HEAD>){ print $_; }
		close HEAD;
	}
}

print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Calendar Viewer Page</TITLE>\n";
print "</HEAD>\n\n";
print "<BODY>\n";
print "<DIV ALIGN=$param{'align'}>\n" if(defined $param{'align'});
my ($starty, $startm, $endy, $endm, $is, $ie, $im, $cnt, $colchk, $apr);
$apr=$param{'apr'};
$param{'apr'}=sqrt($apr*$apr) if($param{'apr'}<0);
if($param{'apr'}<0){
	print "<H2>\n";
	print "<FONT COLOR=#FF0000>apr value is not effective number.</FONT>\n";
	print "<BR>\n";
	holiday::daycheck($toyear, $tomonth, $today);
	print "</H2>\n";
}
elsif($param{'apr'}==0){ printcal::printcal($toyear, $tomonth, $param{'script'}, $param{'align'}, $param{'apr'}, $param{'col'}); }
else{
	print "<TABLE>\n";
	$starty=$toyear;
	$startm=$tomonth-$param{'apr'};
	while($startm<1){
		$starty--;
		$startm+=12;
	}
	$endy=$toyear;
	$endm=$tomonth+$param{'apr'};
	while($endm>12){
		$endy++;
		$endm-=12;
	}
	$colchk=0;
	$cnt=0;
	$is=$startm;
	$ie=$endm;
	while($starty<$endy){
		$cnt++;
		$is=1 if($cnt!=1);
		$ie=12;
		for($im=$is; $im<=$ie; $im++){
			$colchk++;
			print "<TR>\n<TH>\n" if($colchk%$param{'col'}==1);
			printcal::printcal($starty, $im, $param{'script'}, $param{'align'}, $param{'apr'}, $param{'col'});
			print "</TH>\n<TH>\n" if($colchk%$param{'col'}!=0);
			print "</TH>\n</TR>\n" if($colchk%$param{'col'}==0);
		}
		$starty++;
	}
	if($cnt!=0){
		$is=1;
		$ie=$endm;
	}
	for($im=$is; $im<=$ie; $im++){
		$colchk++;
		print "<TR>\n<TH>\n" if($colchk%$param{'col'}==1);
		printcal::printcal($endy, $im, $param{'script'}, $param{'align'}, $param{'apr'}, $param{'col'});
		print "</TH>\n<TH>\n" if($colchk%$param{'col'}!=0);
		print "</TH>\n</TR>\n" if($colchk%$param{'col'}==0);
	}
	print "</TH>\n</TR>\n" if($colchk%$param{'col'}!=0);
	print "</TABLE>\n";
}
my $scrname=$ENV{'SCRIPT_NAME'};
my @scrary=split(/\//, $scrname);
$scrname=~s/$scrary[$#scrary]/$script/;
if(defined $ENV{'PATH_INFO'}){
	my $pathinfo=$ENV{'PATH_INFO'};
	$pathinfo=~s/\/$//;
	$scrname.=$pathinfo;
}
if($param{'footer'} eq ""){
	print "<P>\n";
	print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
	print "<input type=\"hidden\" value=\"$toyear\" name=\"year\">\n";
	print "<input type=\"hidden\" value=\"$tomonth\" name=\"month\">\n";
	print "<input type=\"hidden\" value=\"$param{'script'}\" name=\"script\">\n";
	print "<input type=\"hidden\" value=\"$param{'align'}\" name=\"align\">\n" if(defined $param{'align'});
	print "<input type=\"hidden\" value=\"$param{'apr'}\" name=\"apr\">\n" if(defined $param{'apr'});
	print "<input type=\"hidden\" value=\"$param{'col'}\" name=\"col\">\n" if(defined $param{'col'});
	print "<input type=\"submit\" value=\"戻る\">";
	print "</FORM>\n";
}
print "</DIV>\n" if(defined $param{'align'});
print "</BODY>\n";
print "</HTML>\n";

if(defined $param{'footer'}){
	$param{'footer'}=~s/^\///;
	$fpath=$param{'dir'}."/".$param{'footer'} if(defined $param{'footer'});
	if( -f "$fpath"){
		open TEXT, "$fpath" or die;
		while(<TEXT>){ print $_; }
		close TEXT;
	}
}
exit 0;

