package holiday;

use strict;
use Calendar::Simple;
use base qw(Date::Simple);

sub nkfcmd{
	my $filename="/usr/local/bin/nkf";
	return $filename;
}

sub infile{
	my $filename="rankfile.csv";
	return $filename;
}

sub tmpfile{
	my $filename="sortfile.csv";
	return $filename;
}

sub orgfile{
	my $filename="origchart.csv";
	return $filename;
}

sub outfile{
	my $filename="dutychart.csv";
	return $filename;
}

sub diridx{
	my $filename="index.htm";
	return $filename;
}

sub inptscr{
	my $filename="input.pl";
	return $filename;
}

sub subscr{
	my $filename="submit.pl";
	return $filename;
}

sub calcscr{
	my $filename="calc.pl";
	return $filename;
}

sub viewscr{
	my $filename="view.pl";
	return $filename;
}

sub headprt{
	my $align=shift(@_);
	print "<HTML>\n<HEAD>\n";
	print "<TITLE>Duty Chart Calculation Result Page</TITLE>\n";
	print "</HEAD>\n\n<BODY>\n";
	print "<DIV ALIGN=$align>\n" if($align ne "");
	print "<H2>当番表計算結果</H2>\n";
	print "<P>\n";
}

sub returnprt{
	my $scrname=shift(@_);
	my $align=shift(@_);
	print "<DIV ALIGN=$align>\n" if($align ne "");
	print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
	print "<INPUT type=\"hidden\" value=\"$align\" name=\"align\">\n" if($align ne "");
	print "<INPUT type=\"submit\" value=\"戻る\">\n";
	print "</FORM>\n";
	print "</DIV>\n" if($align ne "");
}

sub whatday{
	my @dparam=@_;
	my $year=shift(@dparam);
	my $month=shift(@dparam);
	my $day=shift(@dparam);
	my $wday=Date::Simple->new($year, $month, $day)->day_of_week;
	my $spday=int(20.8431 + 0.242194 * ($year - 1980) - int(($year - 1980) / 4));
	my $auday=int(23.2488 + 0.242194 * ($year - 1980) - int(($year - 1980) / 4));
	my $holiday;
	if($wday==0){ $holiday=2; }
	elsif($month==3 && $day==$spday){ $holiday=2; }
	elsif($month==3 && $day==$spday+1 && $wday==1){ $holiday=2; }
	elsif($year>=2003 && $month==9 && $day>=15 && $day<22 && $wday==1){ $holiday=2; }
	elsif($year>=2003 && $month==9 && $day==$auday-1 && $wday==2){ $holiday=2; }
	elsif($month==9 && $day==$auday){ $holiday=2; }
	elsif($month==9 && $day==$auday+1 && $wday==1){ $holiday=2; }
	elsif($year<2003 && $month==9 && $day==15){ $holiday=2; }
	elsif($year<2003 && $month==9 && $day==16 && $wday==1){ $holiday=2; }
	elsif($year>=1986 && $month==5 && $day==4){ $holiday=2; }
	elsif($year>=1989 && $month==12 && $day==23){ $holiday=2; }
	elsif($year>=1989 && $month==12 && $day==24 && $wday==1){ $holiday=2; }
	elsif($year>=1996 && $year<2003 && $month==7 && $day==20){ $holiday=2; }
	elsif($year>=1996 && $year<2003 && $month==7 && $day==21 && $wday==1){ $holiday=2; }
	elsif($year>=2003 && $month==7 && $day>=15 && $day<22 && $wday==1){ $holiday=2; }
	elsif($year<2000 && $month==1 && $day==15){ $holiday=2; }
	elsif($year<2000 && $month==1 && $day==16 && $wday==1){ $holiday=2; }
	elsif($year>=2000 && $month==1 && $day>=8 && $day<15 && $wday==1){ $holiday=2; }
	elsif($year<2000 && $month==10 && $day==10){ $holiday=2; }
	elsif($year<2000 && $month==10 && $day==11 && $wday==1){ $holiday=2; }
	elsif($year>=2000 && $month==10 && $day>=8 && $day<15 && $wday==1){ $holiday=2; }
	elsif($month==2 && $day==11){ $holiday=2; }
	elsif($month==2 && $day==12 && $wday==1){ $holiday=2; }
	elsif($month==4 && $day==29){ $holiday=2; }
	elsif($month==4 && $day==30 && $wday==1){ $holiday=2; }
	elsif($month==5 && $day==3){ $holiday=2; }
	elsif($month==5 && $day==5){ $holiday=2; }
	elsif($month==5 && $day==6 && $wday==1){ $holiday=2; }
	elsif($month==5 && $day==6 && $wday==2){ $holiday=2; }
	elsif($month==5 && $day==6 && $wday==3){ $holiday=2; }
	elsif($month==11 && $day==3){ $holiday=2; }
	elsif($month==11 && $day==4 && $wday==1){ $holiday=2; }
	elsif($month==11 && $day==23){ $holiday=2; }
	elsif($month==11 && $day==24 && $wday==1){ $holiday=2; }
	elsif($month==1 && $day==1){ $holiday=2; }
	elsif($month==1 && $day==2){ $holiday=2; }
	elsif($month==1 && $day==3){ $holiday=2; }
	elsif($month==1 && $day==4){ $holiday=2; }
	elsif($month==8 && $day==13){ $holiday=2; }
	elsif($month==8 && $day==14){ $holiday=2; }
	elsif($month==8 && $day==15){ $holiday=2; }
	elsif($month==12 && $day==30){ $holiday=2; }
	elsif($month==12 && $day==31){ $holiday=2; }
	elsif($month==8 && $day==11 && $wday==6){ $holiday=2; }
	elsif($month==8 && $day==12 && ($wday==0 || $wday==3 || $wday==4 || $wday==5 || $wday==6)){ $holiday=2; }
	elsif($month==8 && $day==16 && $wday!=4){ $holiday=2; }
	elsif($month==8 && $day==17 && ($wday==0 || $wday==6)){ $holiday=2; }
	elsif($wday==6){ $holiday=1; }
	else{ $holiday=0; }
	return $holiday;
}

sub dayparam{
	my $year=shift(@_);
	my $fromon=shift(@_);
	my $tomon=shift(@_);
	my $iw=shift(@_);
	my $ih=shift(@_);
	my ($holiday, $paraday, $im, @cal, %param);
	for($im=$fromon; $im<=$tomon; $im++){
		@cal=calendar($im, $year);
		foreach my $week (@cal){
			foreach my $day (@$week){
				if(defined $day){
					$paraday=Date::Simple->new($year, $im, $day)->format('%F');
					$holiday=whatday($year, $im, $day);
					if($holiday==0){
						$iw++;
						$param{$paraday}=$iw;
					}
					else{
						$ih--;
						$param{$paraday}=$ih;
					}
				}
			}
		}
	}
	return ($iw, $ih, %param);
}

sub daycheck{
	my @chkdate=@_;
	my $chkyear=shift(@chkdate);
	my $chkmonth=shift(@chkdate);
	my $chkday=shift(@chkdate);
	my $chkval="no" if($chkyear eq "");
	$ENV{'TZ'}="JST-9" if($chkyear eq "");
	$chkyear=Date::Simple->new()->format('%Y') if($chkyear eq "");
	$chkmonth=Date::Simple->new()->format('%m') if($chkmonth eq "");
	$chkday=Date::Simple->new()->format('%d') if($chkday eq "");
	my $holiday=whatday($chkyear, $chkmonth, $chkday);
	my $prtwday=Date::Simple->new($chkyear, $chkmonth, $chkday)->format('%a');
	my $prtdate=$chkmonth."/".$chkday."/".$chkyear."(".$prtwday.")";
	if($holiday==2){ print "$prtdate is holiday.\n"; }
	elsif($holiday==1){ print "$prtdate is Saturday.\n"; }
	else{ print "$prtdate is weekday.\n"; }
	print "Time zone is $ENV{'TZ'}\n" if($chkval eq "no");
}

1;

