package printcal;

use strict;
use Calendar::Simple;
use lib qw(.);
use holiday;

sub calscr{
	my $filename="calendar.pl";
	return $filename;
}

sub scalscr{
	my $filename="singlecal.pl";
	return $filename;
}

sub wcalscr{
	my $filename="workcal.pl";
	return $filename;
}

sub schedscr{
	my $filename="schedit.pl";
	return $filename;
}

sub schsubscr{
	my $filename="schsubmit.pl";
	return $filename;
}

sub paramscr{
	my $filename="calparam.pl";
	return $filename;
}

sub dcalscr{
	my $filename="dutychartcal.pl";
	return $filename;
}

sub selscr{
	my $filename="dutychartselect.pl";
	return $filename;
}

sub printcal{
my $prtyear=shift(@_);
my $prtmonth=shift(@_);
my $schscr=shift(@_);
my $align=shift(@_);
my $apr=shift(@_);
my $col=shift(@_);
my @prtcal=calendar($prtmonth, $prtyear) if($prtmonth ne "" && $prtyear ne "");
$ENV{'TZ'}="JST-9";
undef $schscr if($schscr eq "no");
my ($daychk, $tomonth, $today, $toyear);
$tomonth=Date::Simple->new()->format('%m');
$tomonth=~s/^0//;
$today=Date::Simple->new()->format('%d');
$today=~s/^0//;
$toyear=Date::Simple->new()->format('%Y');
my @browser = split(/\ /, $ENV{'HTTP_USER_AGENT'});
my ($filename, $scalscr, $pathinfo, $scrname, $scrfile, @scrary);
print "<TABLE>\n<TR>\n";
if($schscr ne ""){
	$scrname=$ENV{'SCRIPT_NAME'};
	@scrary=split(/\//, $scrname);
	$scrfile=$scrary[$#scrary];
	$scalscr=scalscr;
	$scrname=~s/$scrfile/$scalscr/;
	if(defined $ENV{'PATH_INFO'}){
		$pathinfo=$ENV{'PATH_INFO'};
		$pathinfo=~s/\/$//;
		$scrname.=$pathinfo;
	}
	print "<TH>";
	if($scrfile ne $scalscr){
		print "<A HREF=\"$scrname?year=$prtyear&month=$prtmonth&script=$schscr";
		print "&align=$align" if($align ne "");
		print "&apr=$apr" if($apr ne "");
		print "&col=$col" if($col ne "");
		print "\">$prtyear/$prtmonth</A>";
	}
	else{ print "$prtyear/$prtmonth"; }
	print "</TH>\n";
	$scrname=~s/$scalscr/$schscr/;
}
else{ print "<TH>$prtyear/$prtmonth</TH>\n"; }
print "</TR>\n</TABLE>\n";
print "<TABLE>\n";
my %weekday;
$weekday{0}="Sun";
$weekday{1}="Mon";
$weekday{2}="Tue";
$weekday{3}="Wed";
$weekday{4}="Thu";
$weekday{5}="Fri";
$weekday{6}="Sat";
=comment
$weekday{0}="S";
$weekday{1}="M";
$weekday{2}="T";
$weekday{3}="W";
$weekday{4}="T";
$weekday{5}="F";
$weekday{6}="S";
=cut
print "<TR>\n";
my ($iv, $dirpath);
for($iv=0; $iv<=6; $iv++){
	if (defined $weekday{$iv}){
		if($iv==0){ print "<TH><FONT COLOR=#FF0000>$weekday{$iv}</FONT></TH>"; }
		elsif($iv==6){ print "<TH><FONT COLOR=#0000FF>$weekday{$iv}</FONT></TH>"; }
		else{ print "<TH>$weekday{$iv}</TH>"; }
	}
}
print "\n</TR>\n";
foreach my $iw (@prtcal){
	print "<TR>\n";
	foreach my $id (@$iw){
		if(defined $id){
			$daychk=holiday::whatday($prtyear, $prtmonth, $id);
			if($schscr ne ""){
				if(defined $ENV{'PATH_TRANSLATED'}){
					$dirpath=$ENV{'PATH_TRANSLATED'};
					$dirpath=~s/\/$//;
				}
				$filename=Date::Simple->new($prtyear, $prtmonth, $id)->format('%F');
			}
			if($scrfile=~/$scalscr/){
				if($prtyear==$toyear && $prtmonth==$tomonth && $id==$today && $browser[0] eq "Mozilla/5.0"){
					print "<TH><BLINK><A HREF=\"$scrname?year=$prtyear&month=$prtmonth&day=$id&script=$scrfile";
					print "&align=$align" if($align ne "");
					print "&apr=$apr" if($apr ne "");
					print "&col=$col" if($col ne "");
					print "\">$id</A></BLINK></TH>";
				}
				else{
					print "<TH><A HREF=\"$scrname?year=$prtyear&month=$prtmonth&day=$id&script=$scrfile";
					print "&align=$align" if($align ne "");
					print "&apr=$apr" if($apr ne "");
					print "&col=$col" if($col ne "");
					print "\">$id</A></TH>";
				}
			}
			elsif($daychk==2){
				if( -f "$dirpath/$filename"){
					print "<TH><A HREF=\"$scrname?year=$prtyear&month=$prtmonth&day=$id&script=$scrfile";
					print "&align=$align" if($align ne "");
					print "&apr=$apr" if($apr ne "");
					print "&col=$col" if($col ne "");
					print "\">$id</A></TH>";
				}
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today && $browser[0] eq "Mozilla/4.0"){ print "<TH><FONT COLOR=#00FF00>$id</FONT></TH>"; }
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today){ print "<TH><BLINK><FONT COLOR=#FF0000>$id</FONT></BLINK></TH>"; }
				else{ print "<TH><FONT COLOR=#FF0000>$id</FONT></TH>"; }
			}
			elsif($daychk==1){
				if( -f "$dirpath/$filename"){
					print "<TH><A HREF=\"$scrname?year=$prtyear&month=$prtmonth&day=$id&script=$scrfile";
					print "&align=$align" if($align ne "");
					print "&apr=$apr" if($apr ne "");
					print "&col=$col" if($col ne "");
					print "\">$id</A></TH>";
				}
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today && $browser[0] eq "Mozilla/4.0"){ print "<TH><FONT COLOR=#00FF00>$id</FONT></TH>"; }
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today){ print "<TH><BLINK><FONT COLOR=#0000FF>$id</FONT></BLINK></TH>"; }
				else{ print "<TH><FONT COLOR=#0000FF>$id</FONT></TH>"; }
			}
			else{
				if( -f "$dirpath/$filename"){
					print "<TH><A HREF=\"$scrname?year=$prtyear&month=$prtmonth&day=$id&script=$scrfile";
					print "&align=$align" if($align ne "");
					print "&apr=$apr" if($apr ne "");
					print "&col=$col" if($col ne "");
					print "\">$id</A></TH>";
				}
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today && $browser[0] eq "Mozilla/4.0"){ print "<TH><FONT COLOR=#00FF00>$id</FONT></TH>"; }
				elsif($prtyear==$toyear && $prtmonth==$tomonth && $id==$today){ print "<TH><BLINK>$id</BLINK></TH>"; }
				else{ print "<TH>$id</TH>"; }
			}
		}
		else{
			print "<TH>-</TH>";
		}
	}
	print "\n</TR>\n";
}
print "</TABLE>\n";
}

1;

