#!/usr/bin/perl

use strict;
use lib qw(.);
use printcal;

my $script=printcal::calscr;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Work Calendar Viewer Page</TITLE>\n";
print "</HEAD>\n";
print "<BODY>\n";
my @qryary = split('&', $ENV{'QUERY_STRING'}) if ($ENV{'QUERY_STRING'} ne "");
my (%param, $name, $value, $im);
foreach my $var (@qryary){
	($name, $value) = split('=', $var);
	$param{$name} = $value;
}
$param{'year'}=Date::Simple->new()->format('%Y') if($param{'year'} eq "");
print "<DIV ALIGN=$param{'align'}>\n" if(defined $param{'align'});
print "<TABLE>\n";
my $cyear=$param{'year'};
for($im=4; $im<=12; $im++){
	print "<TR>\n<TH>\n" if($im%$param{'col'}==1);
	printcal::printcal($cyear, $im, $param{'script'}, $param{'align'}, $param{'apr'}, $param{'col'});
	print "</TH>\n<TH>\n" if($im%$param{'col'}!=0);
	print "</TH>\n</TR>\n" if($im%$param{'col'}==0);
}
$cyear+=1;
for($im=1; $im<=3; $im++){
	print "<TR>\n<TH>\n" if($im%$param{'col'}==1);
	printcal::printcal($cyear, $im, $param{'script'}, $param{'align'}, $param{'apr'}, $param{'col'});
	print "</TH>\n<TH>\n" if($im%$param{'col'}!=0);
	print "</TH>\n</TR>\n" if($im%$param{'col'}==0);
}
print "</TABLE>\n";
my $scrname=$ENV{'SCRIPT_NAME'};
my @scrary=split(/\//, $scrname);
$scrname=~s/$scrary[$#scrary]/$script/;
if(defined $ENV{'PATH_INFO'}){
	my $pathinfo=$ENV{'PATH_INFO'};
	$pathinfo=~s/\/$//;
	$scrname.=$pathinfo;
}
print "<P>\n";
print "<FORM METHOD=\"GET\" ACTION=\"$scrname\">\n";
print "<input type=\"hidden\" value=\"$param{'year'}\" name=\"year\">\n";
print "<input type=\"hidden\" value=\"$param{'script'}\" name=\"script\">\n" if(defined $param{'script'});
print "<input type=\"hidden\" value=\"$param{'align'}\" name=\"align\">\n" if(defined $param{'align'});
print "<input type=\"hidden\" value=\"$param{'apr'}\" name=\"apr\">\n" if(defined $param{'apr'});
print "<input type=\"hidden\" value=\"$param{'col'}\" name=\"col\">\n" if(defined $param{'col'});
print "<input type=\"hidden\" value=\"$param{'header'}\" name=\"header\">\n" if(defined $param{'header'});
print "<input type=\"hidden\" value=\"$param{'footer'}\" name=\"footer\">\n" if(defined $param{'footer'});
print "<input type=\"submit\" value=\"戻る\">\n";
print "</FORM>\n";
print "</DIV>\n" if(defined $param{'align'});
print "</BODY>\n";
print "</HTML>\n";
exit 0;

